#include "driver.h"
#include <math.h>


static int channel[MAX_DAC];
static int output[MAX_DAC];
static int UnsignedVolTable[256];
static int SignedVolTable[256];


/* Start Emu Plus */

FILE *dac_ofp = 0;
int  dac_i_log, dac_i_filetest = 0;
char dac_filename[20];

/* End Emu Plus */

static void DAC_update(int num,void *buffer,int length)
{
	short *buf = buffer;
	int out = output[num];
	/* Start Emu Plus */
	extern int logsound;
	if (logsound) {
          sprintf(dac_filename, "dac%04d.pcm", dac_i_filetest);

          if (!dac_ofp) {
            if ((dac_ofp = fopen(dac_filename,"r")) != NULL) {
              fclose(dac_ofp);              
              while ((dac_ofp = fopen(dac_filename,"r")) != NULL) {
                fclose(dac_ofp);
                dac_i_filetest++;  
                sprintf(dac_filename, "dac%04d.pcm", dac_i_filetest);
              }              
            }
            
            dac_ofp = fopen(dac_filename, "wb");
          }

          if (dac_ofp) {
            for(dac_i_log=0;dac_i_log<length;dac_i_log++)
              fprintf(dac_ofp,"%c",( ((unsigned char*)buffer)[dac_i_log] ) );
          }

	}	
	/* End Emu Plus */
	while (length--) *(buf++) = out;
}


void DAC_data_w(int num,int data)
{
	int out = UnsignedVolTable[data];

	if (output[num] != out)
	{
		/* update the output buffer before changing the registers */
		stream_update(channel[num],0);
		output[num] = out;
	}
}


void DAC_signed_data_w(int num,int data)
{
	int out = SignedVolTable[data];

	if (output[num] != out)
	{
		/* update the output buffer before changing the registers */
		stream_update(channel[num],0);
		output[num] = out;
	}
}


static void DAC_build_voltable(void)
{
	int i;


	/* build volume table (linear) */
	for (i = 0;i < 256;i++)
	{
		UnsignedVolTable[i] = i * 0x101 / 2;	/* range      0..32767 */
		SignedVolTable[i] = i * 0x101 - 0x8000;	/* range -32768..32767 */
	}
}


int DAC_sh_start(const struct MachineSound *msound)
{
	int i;
	const struct DACinterface *intf = msound->sound_interface;


	DAC_build_voltable();

	for (i = 0;i < intf->num;i++)
	{
		char name[40];


		sprintf(name,"DAC #%d",i);
		channel[i] = stream_init(name,intf->mixing_level[i],Machine->sample_rate,16,
				i,DAC_update);

		if (channel[i] == -1)
			return 1;

		output[i] = 0;
	}

	return 0;
}
